﻿angular.module('Solus.RegistroDispositivoController', [])

.controller('PopupRegistroDispositivoCtrl', function ($scope, $ionicPopup, $location, $http, $webSql, $state, $rootScope, ConfiguracoesService, DbService, localStorageService, RegistroDispositivoService, StatusService) {
    //Inicia com licenciada e botão próximo desabilitado.
    $scope.$root.selectLicenciadas = "select-hide";
    $scope.$root.btnProximo = "label-hide";
    //Esconder botão back
    $scope.hideBackButton = true;

    $scope.showPopup = function (_url) {
        //$rootScope.UrlService = _url;
        var confirmPopup = $ionicPopup.confirm({
            title: 'Confirmar registro',
            template: 'Deseja solicitar o registro desse dispositivo?',
            buttons: [{ text: 'Não', onTap: function (e) { return false; } },
                      { text: '<b>Sim</b>', type: 'button-positive', onTap: function (e) { return true; } }]
        });
        confirmPopup.then(function (res) {
            if (res) {
                $rootScope.Processando = true;
                //Se não preencheu URL 
                if ($rootScope.UrlService == '') {
                    $scope.$root.lblPreenchaURL = "label-show";
                    $scope.$root.lblAguardandoAtivacao = "label-hide";
                    $rootScope.Processando = false;
                }
                else {
                    $rootScope.mensagemErro = '';
                    $scope.$root.lblPreenchaURL = "label-hide";
                    ConfiguracoesService.GetMacAddress(function (result) { });
                    //$rootScope.numMAC = numMAC.replace(":", "");
                    //$scope.$root.lblAguardandoAtivacao = "label-show";
                    $rootScope.db = $webSql.openDatabase("Solus", versaoDB, "Database Solus", 200000);
                    $rootScope.db.update("TB_CONFIGURACOES", { "DSC_URL": _url }, { 'id': 1 });
                    _versao = localStorageService.get('Config').VersaoApp;
                    localStorageService.set('Config', { UrlServico: _url, VersaoApp: _versao });
                    
                    //Chamando método na camada de serviço
                    ConfiguracoesService.ListaLicenciadas(function (result, $scope) { });
                    //Cerragando dados de configurações
                    DbService.CarregarDadosConfiguracoes(function () { });
                    $rootScope.Processando = false;
                }
            } else {
                console.log(res);
                $rootScope.Processando = false;
            }
        });
    };
    $scope.limparURL = function () {
        $scope.url = '';
    }

    $scope.LicenciadaChange = function (licenciada) {
        console.log('Licenciada', licenciada);
        $rootScope.btnProximo = "label-show";
        localStorageService.set('Licenciada', licenciada);
    }

    $scope.Proximo = function () {
        if ($rootScope.licenciadas.length == 1) {
            //Entrar automáticamente.
            RegistroDispositivoService.BuscaUnidadeMac().then(function (dados) {
                console.log('dados ficha', dados);
                if (dados.erro != null) {
                    $ionicPopup.alert({
                        title: 'Erro ao continuar',
                        template: dados.erro
                    });
                } else {
                    //Setando dados Geral
                    localStorageService.set('Usuario', { VersaoWs: dados.VersaoWs, versaoAPP: '1.0.23', Login: dados.Motorista, NomeUsuario: dados.Motorista, UsuarioID: dados.RemoteID, Gerente: 'N', NumUnidade: dados.RemoteID, Cor: dados.Cor, Modelo: dados.Modelo });
                    $rootScope.NumUnidade = dados.RemoteID;
                    console.log('$rootScope.NumUnidade', $rootScope.NumUnidade);
                    localStorageService.set('Unidade', { Status: dados.Status, DescricaoStatus: dados.DescricaoStatus });
                    $rootScope.StatusUnidade = dados.Status;
                    $rootScope.DescricaoStatusUnidade = dados.DescricaoStatus;

                    //Corrida 
                    localStorageService.set('Corrida', { Ativo: 'false', Dados: '[]' });
                    //Carregar os status 
                    StatusService.CarregarStatus();

                    //RegistroDispositivoService.ListarStatus().then(function (dados) {
                        $location.url('/tab/dash', true);
                    //});                    
                }
            });
        }
        else if ($rootScope.licenciadas.length > 1) {
            var caminho = '/login';
            $location.replace();
            $location.path(caminho);
        }
        //$state.go('login');        
    }

    // Desclarar método init
    var init = function () {
        $rootScope.metodoListaLicenciadas = "ListaLicenciadas";
        $rootScope.metodoListaUnidades = "listaUnidadesLicenciada";
        $rootScope.metodoListaMensagens = "ListaMensagens";
        $rootScope.Velocidade = 0;
        //Retirar comentário
        //CorridaService.RecuperarCorrida(function () { });
        //StatusService.ListaStatusNaoEnviado(function () { });
        //if($rootScope.UrlService == '')
        $rootScope.UrlService = 'http://cloud01.gprtecnologia.com.br:82/wssolus.svc/';
        DbService.CarregarDadosConfiguracoes(function () { });
    };

    // Executar init
    init();

});