﻿angular.module('Solus.ConfiguracoesService', [])

SolusApp.factory('ConfiguracoesService', function ($http, $webSql, $rootScope, $location, $ionicPopup, $timeout, localStorageService) {

    function LimparTodosDados() {
        LimparDadosTimeout();
        LimparDadosLogin();
    }

    function LimparDadosLogin() {
        $rootScope.cpf = '';
        $rootScope.senha = '';
    }

    function LimparDadosTimeout() {
        $timeout.cancel($rootScope.VerificarCorridaID);
        $timeout.cancel($rootScope.AddPositionTimeOut);
        $timeout.cancel($rootScope.EnviarRastreamentoID);
    }

    return {
        GetMacAddress: function (callback) {
            try {
                window.MacAddress.getMacAddress(
            function (macAddress) {
                $rootScope.numMAC = macAddress.replace(":", "");
                $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                return $rootScope.numMAC;
            },
               function (fail) { alert(fail); });
            }
            catch (err) {
                try {
                    console.log("error MacAddress: " + err);
                    console.log("device.uuid: " + device.uuid);
                    $rootScope.numMAC = device.uuid.replace(":", "");
                    $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                    $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                    $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                    $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                    $rootScope.numMAC = $rootScope.numMAC.replace(":", "");
                    var mac = "001122334455";
                    $rootScope.numMAC = mac;
                    console.log($rootScope.numMAC);
                    return $rootScope.numMAC;
                    
                }
                catch (err2) {
                    console.log("device.uuid: " + err2);
                    var mac = "001122334455";
                    $rootScope.numMAC = mac;
                    console.log($rootScope.numMAC);
                    return $rootScope.numMAC;
                }
            }
        },
        GetUrlService: function (callback) {
            try {
                console.log("GetUrlService",true);
            }
            catch (err) {
                console.log("GetUrlService", err);
            }
        },
        ListaLicenciadas: function (callback) {
            //console.log(callback);
            //Atualizar registro no banco.
            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoListaLicenciadas + "/" + localStorageService.get('Config').VersaoAPP + "/" + $rootScope.numMAC;
            console.log(_url);
            $http(
            {
                method: "GET",
                url: _url
            })
            .error(function (error) {
                //console.log('Error: ' + error);
                //$rootScope.mensagemErro = 'error: Serviço não encontrado';

                //Mostrar Erro
                var alertPopup = $ionicPopup.alert({
                    title: 'Registro de Dispositivo',
                    template: 'Não foi possível registrar dispositivo.'
                });
            })
            .success(function (data, status, headers, config) {
                $rootScope.db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
                $rootScope.db.update("TB_CONFIGURACOES", { "DSC_URL": $rootScope.UrlService }, {
                    'id': 1
                });
                console.log("console.log(data);",data);
                $rootScope.licenciadas = [];
                $rootScope.licenciadas = data;
                if ($rootScope.licenciadas.length == 0) {
                    $ionicPopup.alert({
                        title: 'Licenciadas',
                        template: 'Nenhuma licenciada encontrada.'
                    });
                }
                else if ($rootScope.licenciadas.length > 0) {
                    $rootScope.lnlDispositivoAtivado = 'label-hide';
                    $rootScope.lblAguardandoAtivacao = "label-hide";
                    $rootScope.selectLicenciadas = "select-show";
                    $rootScope.tblLicenciadas = "table-show";
                    $rootScope.resultado = data[0].erro;
                }
                //console.log("data", JSON.stringify(data));
                
            });
        },
        ListaUnidades: function (callback, $scope) {
            //console.log(callback);
            //Atualizar registro no banco.
            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoListaUnidades + "/" + $rootScope.versaoAPP + "/" + $rootScope.numMAC + "/" + localStorageService.get('Licenciada').CNPJ;
            console.log('url unidades',_url);
            $http(
            {
                method: "GET",
                url: _url
            })
            .error(function (error) {
                console.log('Error: ' + error);
                //$scope.mensagem = 'error: Serviço não encontrado';
            })
            .success(function (data, status, headers, config) {
                $rootScope.Unidades = [];
                for (var i = 0; i < data.Unidades.length; i++) {
                    $rootScope.Unidades.push(data.Unidades[i]);
                    //console.log("data[i]", data.Unidades[i]);
                }
                $rootScope.db.update("TB_CONFIGURACOES", { "NUM_CNPJ_LICENCIADA": $rootScope.NumCnpj }, {'id': 1 });
                console.log("unidade", JSON.stringify(data));
                //console.log("test", $rootScope.Unidades);
                if (data.erro != '') {
                    $rootScope.btnProximo = "label-show";
                    $rootScope.lblAguardandoAtivacao = "label-hide";                    
                }
                else {
                    $rootScope.lblAguardandoAtivacao = "label-show";
                    $rootScope.btnProximo = "label-hide";
                }
            });
        },
        Sair: function (callback) {
            /*
            1-Limpar os dados da tabela de Configurações, referente ao usuário e a unidade.
            2-Limpar o processamento da busca de corrida
            3-Encaminhar para a página de login
            */
            LimparTodosDados();
            //$timeout.cancel($rootScope.VerificarCorridaID);
            //$timeout.cancel($rootScope.AddPositionTimeOut);
            //$timeout.cancel($rootScope.EnviarRastreamentoID);
            console.log("Sair configurações service");
            //1-
            //$rootScope.db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
            $rootScope.db.update("TB_CONFIGURACOES", { "ID_USUARIO": "", "DSC_NOME": "", "NUM_UNIDADE": "", "COD_STATUS_UNIDADE": ""}, {'id': 1});
            //2-

            //3-
            $location.url('/login', true);
            //$location.path('/login');
            //4-
            
        },
        Reset: function (callback) {
            //$timeout.cancel($rootScope.VerificarCorridaID);
            //$timeout.cancel($rootScope.AddPositionTimeOut);
            //$timeout.cancel($rootScope.EnviarRastreamentoID);
            LimparTodosDados();
            console.log("Entrou Reset Service");
            $rootScope.dadosCorrida = [];
            //1-Limpar banco de dados
            $rootScope.db.update("TB_CONFIGURACOES", { "ID_USUARIO": "", "DSC_NOME": "", "NUM_UNIDADE": "", "COD_STATUS_UNIDADE": "", "NUM_CNPJ_LICENCIADA": "", "DSC_LOGO_LICENCIADA": "" }, { 'id': 1 });
            $rootScope.db.del("TB_CORRIDA", { "NUM_CORRIDA": { "value": 'IS NOT NULL' } });
            $rootScope.db.del("TB_CORRIDA_ATENDIMENTO", { "COD_STATUS": { "value": 'IS NOT NULL' } });
            $rootScope.db.del("TB_MENSAGEM", { "DSC_MENSAGEM": { "value": 'IS NOT NULL' } });
            $rootScope.db.del("TB_RASTREAMENTO", { "DataHora": { "value": 'IS NOT NULL' } });
            $rootScope.db.del("TB_STATUS", { "COD_STATUS": { "value": 'IS NOT NULL' } });
            $rootScope.db.del("TB_TIPO_MENSAGEM", { "MensagemID": { "value": 'IS NOT NULL' } });
            //2-Redirecionar para a tela de registro de dispositivo
            $location.path('/registroDispositivo');
        },
        LimparDadosTimeout: function () {
            LimparDadosTimeout();
        }
    }
});