﻿angular.module('Solus.CorridaService', [])

SolusApp.factory('CorridaService', function ($http, $webSql, $rootScope, ProService, $ionicPopup, $timeout, StatusService/*, push*/, localStorageService) {

    function GravaCorridaAtendimento(resultado, callback) {

        //Só apresenta se tiver nova corrida.
        if (callback.Itens.length > 0 && resultado !== undefined) {
            console.log("Gravando corrida não aceita", JSON.stringify(callback));
            var objAtendimento = { DATA: '', COD_STATUS: '', NUM_ATENDIMENTO: '', LATITUDE: '', LONGITUDE: '', FLG_ENVIADO: '' };

            var corrida = '{';
            angular.forEach(callback.Itens, function (campos, key) {
                corrida = corrida + '"' + campos["Campo"] + '":"' + campos["Valor"] + '",';
            }, null);
            corrida = corrida.substring(0, corrida.length - 1) + '}';
            //console.log("Corrida gravada", corrida);
            var codStatus = resultado ? 'AR' : 'AD';

            corrida = JSON.parse(corrida);
            objAtendimento.DATA = ProService.FormatDataRastreamento(new Date());
            objAtendimento.COD_STATUS = codStatus;
            objAtendimento.FLG_ENVIADO = 'S';
            objAtendimento.LATITUDE = $rootScope.Latitude;
            objAtendimento.LONGITUDE = $rootScope.Longitude;
            objAtendimento.NUM_ATENDIMENTO = $rootScope.AtendimentoID;

            var _dados = JSON.parse('{ "versaoApp ": "' + localStorageService.get('Config').VersaoApp + '", "cnpj": "' +
            localStorageService.get('Licenciada').CNPJ + '", "macAddr": "' + $rootScope.numMAC + '", "unidade": "' +
            localStorageService.get('Usuario').NumUnidade + '", "status": "' + objAtendimento.COD_STATUS + '", "atendimentoID": "' +
            objAtendimento.NUM_ATENDIMENTO + '", "Latitude": "' + objAtendimento.LATITUDE + '", "Longitude": "' +
            objAtendimento.LONGITUDE + '", "Velocidade": "' + corrida.Velocidade + '", "DataHora": "' + ProService.FormatDataRastreamento(new Date()) + '" }');
            //StatusService.AtualizarStatus(objAtendimento.COD_STATUS);
            console.log("Corrida _dados", JSON.stringify(_dados));
            
            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoAtualizaStatus;
            console.log("Corrida _url", _url);
            $http(
            {
                method: "POST",
                data: _dados,
                url: _url
            })
            .error(function (error) {
                console.log('Error: ' + error);
            })
            .success(function (callback) {
                $rootScope.StatusUnidade = objAtendimento.COD_STATUS;
                pegaDescricaoStatus($rootScope.StatusUnidade);
            });
            console.log("Corrida atendimento", JSON.stringify(objAtendimento));
            $rootScope.db.insert("TB_CORRIDA_ATENDIMENTO", objAtendimento).then(function (results) {});
            $rootScope.db.update("TB_CONFIGURACOES", { "COD_STATUS_UNIDADE": codStatus }, { 'id': 1 });
            if (codStatus == "AD") {
                console.log('Corrida rejeitada', 'true');
                $rootScope.db.del("TB_CORRIDA", { "NUM_CORRIDA": { "value": 'IS NOT NULL' } });
            }
        }
    }

    function ConfirmarCorrida(resultado, callback) {
        
        if (!!resultado && resultado) {
            console.log("Corrida aceita carrega Corrida", JSON.stringify(callback));
            console.log("Corrida aceita carrega resultado", JSON.stringify(resultado));
            $rootScope.dadosCorrida = [];
            $rootScope.dadosCorridaGeral = [];
            
            //Só apresenta se tiver nova corrida.
            var qtdCampos = callback.Itens.length;
            if (qtdCampos > 0) {
                //var corrida = '{';
                angular.forEach(callback.Itens, function (campos, key) {
                    console.log("campos", campos);
                    //Mostrando campos na tela
                    if (campos['Visivel'] == 'S') {
                        $rootScope.dadosCorrida.push(JSON.parse('{ "Campo" :"' + campos['Texto'] + '", "Valor": "' + campos['Valor'] + '","Visivel" : "' + campos['Visivel'] + '"}'));
                    }else {
                    	$rootScope.dadosCorridaGeral.push(JSON.parse('{ "Campo" :"' + campos['Texto'] + '", "Valor": "' + campos['Valor'] + '","Visivel" : "' + campos['Visivel'] + '"}'));
                    	}
                }, null);
                localStorageService.set('Corrida', { Ativo: true, Dados: JSON.stringify($rootScope.dadosCorrida) });
                localStorageService.set('CorridaGeral', { Ativo: true, Dados: JSON.stringify($rootScope.dadosCorridaGeral) });
                $rootScope.Corrida = JSON.parse(localStorageService.get('Corrida').Dados);
                $rootScope.CorridaAtiva = localStorageService.get('Corrida').Ativo;
            } else {
                $rootScope.dadosCorrida = JSON.parse('[{"Campo": "Aguardando novo atendimento !", "Valor": "", "Visivel": "S" }]');
                console.log(JSON.stringify($rootScope.dadosCorrida));
            }
        }
        GravaCorridaAtendimento(resultado, callback);
    }

    function corridaService__verificarNovaCorrida(callback) {
        $rootScope.Processando = true;
        //console.log('$rootScope.Processando: ', $rootScope.Processando);
        StatusService.ListaStatusNaoEnviado(function () { });
        $rootScope.db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        $rootScope.db.select("TB_CORRIDA", {
            "NUM_CORRIDA": {
                "value": 'IS NOT NULL'
            }
        }).then(function (results) {
            $rootScope.metodoCarregaAtendimento = 'CarregaAtendimento';
            //console.log("Verifica se pode buscar corrida...");
            var corridaAtiva = results.rows.length;
            //console.log("corridaAtiva...", corridaAtiva);
            //Somente ir buscar nova corrida se tabela CORRIDA estiver vazia. 
            if (corridaAtiva === 0) {
                //console.log("Buscando corrida...");
                var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoCarregaAtendimento + '/' + localStorageService.get('Usuario').versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ + '/' + localStorageService.get('Usuario').NumUnidade;
                console.log("_url...", _url);
                $http(
                {
                    method: "GET",
                    url: _url
                })
                .error(function (error) {
                    console.log('Error: ' + error);
                })
                .success(function (callback) {
                    var resultado = false;
                    if (callback.CodigoRetorno == "1") {
                        if(callback.Status == 'LI')
                            localStorageService.set('Unidade', { Status: 'LI', DescricaoStatus: 'Livre' });
                        else
                            localStorageService.set('Unidade', { Status: 'OC', DescricaoStatus: 'Ocupado' });
                        $rootScope.Unidade = { NumUnidade: localStorageService.get('Usuario').NumUnidade, Status: localStorageService.get('Unidade').Status, DescricaoStatus: localStorageService.get('Unidade').DescricaoStatus };
                    }
                    else {
                        var corridaJaConfirmada = callback.Status;
                        console.log("Call back carrega corrida", JSON.stringify(callback));

                        //Inserindo dados da corrida na tabela corrida
                        var qtdCampos = callback.Itens.length;
                        console.log("qtdCampos", qtdCampos);
                        if (qtdCampos > 0) {
                            var corrida = '{';
                            angular.forEach(callback.Itens, function (campos, key) {
                                console.log("campos", campos);
                                corrida = corrida + '"' + campos["Campo"] + '":"' + campos["Valor"] + '",';
                                //Mostrando campos na tela
                            }, null);
                            corrida = corrida.substring(0, corrida.length - 1) + '}';
                            console.log("corrida", corrida);
                            //Inserir corrida no banco de dados
                            $rootScope.db.insert("TB_CORRIDA", JSON.parse(corrida)).then(function (results) {
                            });
                            $rootScope.db.select("TB_CORRIDA", {
                                "NUM_CORRIDA": {
                                    "value": 'IS NOT NULL'
                                }
                            }).then(function (results) {
                                if (results.rows.length > 0)
                                    $rootScope.AtendimentoID = results.rows.item(0).NUM_CORRIDA;
                                console.log('AtendimentoID', $rootScope.AtendimentoID);
                            });
                        }
                        //Alerta sonoro de uma nova corrida...
                        try{
                            navigator.notification.vibrate(3000);
                            navigator.notification.beep(5);
                        } catch (ex) {

                        }
                        //TESTE
                        /*
                        var result = push.registerPush(function (result) {
                            if (result.type === 'registration') {
                                localStorage.setItem('device_id', result.id);
                                localStorage.setItem('device', result.device);
                            }
                        });*/
                        //TESTE


                        console.log("Verifica se aceita corrida");
                        if (corridaJaConfirmada == 'XX') {
                            var confirmPopup = $ionicPopup.confirm({
                                title: 'Novo Atendimento',
                                template: 'Um novo atendimento foi encaminhado para essa unidade, confirmar atendimento?',
                                buttons: [{ text: 'Não', onTap: function (e) { return false; } },
                                          { text: '<b>Sim</b>', type: 'button-positive', onTap: function (e) { return true; } }]
                            });
                            confirmPopup.then(function (res) {
                                console.log("Resultado do popup " + res);
                                ConfirmarCorrida(res, callback);

                            });
                        }
                        else {
                            ConfirmarCorrida(true, callback);
                        }
                    }
                });
            } else {
                //Localizando status da unidade
                $rootScope.db.select("TB_CONFIGURACOES", {
                    "ID": {
                        "value": '1'
                    }
                }).then(function (results) {
                    if (results.rows.length > 0) {
                        $rootScope.StatusUnidade = results.rows.item(0).COD_STATUS_UNIDADE;
                        pegaDescricaoStatus($rootScope.StatusUnidade);
                    }
                    console.log("Localizando Corrida...");

                })
            }
        });
        
        $rootScope.VerificarCorridaID = $timeout(corridaService__verificarNovaCorrida, 10000);
        //console.log('$rootScope.VerificarCorridaID', $rootScope.VerificarCorridaID);
        //console.log('$rootScope.Processando: ', $rootScope.Processando);
        $rootScope.Processando = false;
    }

    function pegaDescricaoStatus(Codstatus) {
        var db;
        db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        db.select("TB_STATUS", {
            "COD_STATUS": {
                "value": Codstatus//$rootScope.StatusUnidade
            }
        }).then(function (results) {
            if (results.rows.length > 0)
                $rootScope.DescricaoStatusUnidade = results.rows.item(0).DSC_STATUS;
        })
    }

    function armazenarCorrida(callback) {
        $rootScope.db.select("TB_CORRIDA", {
            "NUM_CORRIDA": {
                "value": 'IS NOT NULL'
            }
        }).then(function (results) {
            if (results.rows.length == 0) {
                //Inserindo dados da corrida na tabela corrida
                var qtdCampos = callback.Itens.length;
                $rootScope.dadosCorrida = [];
                console.log("qtdCampos", qtdCampos);
                if (qtdCampos > 0) {
                    var corrida = '{';
                    angular.forEach(callback.Itens, function (campos, key) {
                        console.log("campos", campos);
                        corrida = corrida + '"' + campos["Campo"] + '":"' + campos["Valor"] + '",';
                        //Montando dados da corrida recuperada
                        if (campos['Visivel'] == 'S') {
                            $rootScope.dadosCorrida.push(JSON.parse('{ "Campo" :"' + campos['Texto'] + '", "Valor": "' + campos['Valor'] + '","Visivel" : "' + campos['Visivel'] + '"}'));
                        }
                        //Mostrando campos na tela
                    }, null);
                    corrida = corrida.substring(0, corrida.length - 1) + '}';
                    console.log("corrida", corrida);
                    //Inserir corrida no banco de dados
                    $rootScope.db.insert("TB_CORRIDA", JSON.parse(corrida)).then(function (results) {
                    });
                    $rootScope.db.select("TB_CORRIDA", {
                        "NUM_CORRIDA": {
                            "value": 'IS NOT NULL'
                        }
                    }).then(function (results) {
                        if (results.rows.length > 0)
                            $rootScope.AtendimentoID = results.rows.item(0).NUM_CORRIDA;
                        console.log('AtendimentoID', $rootScope.AtendimentoID);
                    })
                }
            }
        });
    }
   

    return {
        VerificarNovaCorrida: function (callback) {
            corridaService__verificarNovaCorrida(callback)
            //StatusService.AtualizarStatus(callback);
        },
        GerarAtendimentoAutomatico: function (callback) {
            $rootScope.metodoGerarAtendimentoAutomatico = "NovoAtendimento";
            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoGerarAtendimentoAutomatico + '/' + $rootScope.versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ + '/' + $rootScope.NumUnidade;
            console.log("_url...", _url);
            $http(
            {
                method: "GET",
                url: _url
            })
            .error(function (error) {
                console.log('Error: ' + error);
                //Mostrar Erro
                var alertPopup = $ionicPopup.alert({
                    title: 'Gerar atendimento',
                    template: 'Não foi possível gerar atendimento.' + error
                });
            })
            .success(function (callback) {
                var resultado = false;
                if (callback.CodigoRetorno == "1") {
                    var alertPopup = $ionicPopup.alert({
                        title: 'Gerar atendimento',
                        template: callback.erro
                    });
                }
                else {
                    var alertPopup = $ionicPopup.alert({
                        title: 'Atendimento gerado com sucesso',
                        template: 'Aguarde enquanto carregamos o novo atendimento.'
                    });

                    console.log("Call back NovoAtendimento", JSON.stringify(callback));
                   
                }
            });
        },
        RecuperarCorrida: function (callback) {
            $rootScope.db.select("TB_CORRIDA", {
                "NUM_CORRIDA": {
                    "value": 'IS NOT NULL'
                }
            }).then(function (results) {
                if (results.rows.length == 0) {
                    $rootScope.metodoResgataAtendimento = "ResgataAtendimento";
                    var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoResgataAtendimento + '/' + localStorageService.get('Usuario').versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ + '/' + $rootScope.NumUnidade + '/' + $rootScope.AtendimentoID;
                    console.log("_url metodoResgataAtendimento", _url);
                    $http(
                    {
                        method: "GET",
                        url: _url
                    })
                    .error(function (error) {
                        console.log('Error: ' + error);
                    })
                    .success(function (callback) {
                        if (callback.CodigoRetorno == "1") {

                        }
                        else {
                            console.log("Call back NovoAtendimento", JSON.stringify(callback));

                            armazenarCorrida(callback);

                            ////Inserindo dados da corrida na tabela corrida
                            //var qtdCampos = callback.Itens.length;
                            //$rootScope.dadosCorrida = [];
                            //console.log("qtdCampos", qtdCampos);
                            //if (qtdCampos > 0) {
                            //    var corrida = '{';
                            //    angular.forEach(callback.Itens, function (campos, key) {
                            //        console.log("campos", campos);
                            //        corrida = corrida + '"' + campos["Campo"] + '":"' + campos["Valor"] + '",';
                            //        //Montando dados da corrida recuperada
                            //        if (campos['Visivel'] == 'S') {
                            //            $rootScope.dadosCorrida.push(JSON.parse('{ "Campo" :"' + campos['Texto'] + '", "Valor": "' + campos['Valor'] + '","Visivel" : "' + campos['Visivel'] + '"}'));
                            //        }
                            //        //Mostrando campos na tela
                            //    }, null);
                            //    corrida = corrida.substring(0, corrida.length - 1) + '}';
                            //    console.log("corrida", corrida);
                            //    //Inserir corrida no banco de dados
                            //    $rootScope.db.insert("TB_CORRIDA", JSON.parse(corrida)).then(function (results) {
                            //    });
                            //    $rootScope.db.select("TB_CORRIDA", {
                            //        "NUM_CORRIDA": {
                            //            "value": 'IS NOT NULL'
                            //        }
                            //    }).then(function (results) {
                            //        if (results.rows.length > 0)
                            //            $rootScope.AtendimentoID = results.rows.item(0).NUM_CORRIDA;
                            //        console.log('AtendimentoID', $rootScope.AtendimentoID);
                            //    })
                            //}
                        }
                    });
                }
            });
        },
        GravaCorridaAtendimento: function (callback) {
            armazenarCorrida(callback);
        }        
    }
});