﻿angular.module('Solus.GpsService', [])

SolusApp.factory('GpsService', function ($http, $webSql, $rootScope, $timeout, ProService, localStorageService) {

	
	
    function onErrorGPS(code) {
    	
    	console.log(code);
        if (code == 1)
            return 'Usuário negou a conexão com GPS.';
        else if (code == 2)
            return 'Nenhuma conexão com GPS.';
        else
            return 'Tempo esgotado na conexão com GPS .';
    };

    function LatLon(lat, lon, radius) {
        if (typeof (radius) == 'undefined') radius = 6371;  // earth's mean radius in km

        this.lat = Number(lat);
        this.lon = Number(lon);
        this.radius = Number(radius);
    };

    function onSucessoGPS(position) {
    	console.log('SUCESSO GPS', position);
    	$rootScope.dadosMapa = position;
        $rootScope.Processando = true;
        //Velocidade
        //if (currentUpdate) lastUpdate = currentUpdate;
        //Posição atual
        //console.log("Rastrear 02", JSON.stringify(position));
        currentUpdate = {
            position: new LatLon(position.coords.latitude, position.coords.longitude),
            time: new Date()
        };
        //Se não tem última posição 
        //if (!lastUpdate) return;
        ////Dados posição atual
        //currentUpdate.deltaDistMetres = lastUpdate.position.distanceTo(currentUpdate.position) * 1000;
        //currentUpdate.deltaTimeSecs = (currentUpdate.time - lastUpdate.time) * 1000;
        //currentUpdate.speed = (currentUpdate.deltaDistMetres / currentUpdate.deltaTimeSecs);
        //currentUpdate.accelerationGPS = (currentUpdate.speed - lastUpdate.speed) / currentUpdate.deltaTimeSecs;

        //console.log("Distance moved: " + currentUpdate.deltaDistMetres + " m; Avg speed: " + currentUpdate.speed + " m/s; Acceleration: " + currentUpdate.accelerationGPS + "m/s/s");
        var lat = position.coords.latitude;
        var lon = position.coords.longitude;
        var pos = 0;
        $rootScope.Latitude = lat;
        $rootScope.Longitude = lon;

        //1-Pegar a unidade
        $rootScope.db.select("TB_CONFIGURACOES", { "ID": { "value": 'IS NOT NULL' } })
            .then(function (results) {
            if (results.rows.length > 0)
                $rootScope.NumUnidade = results.rows.item(0).NUM_UNIDADE;
        });
        $rootScope.AtendimentoID = 0;
        //2-Pegar O ATENDIMENTO 
        $rootScope.db.select("TB_CORRIDA", { "NUM_CORRIDA": { "value": 'IS NOT NULL' } })
            .then(function (results) {
                if (results.rows.length > 0)
                    $rootScope.AtendimentoID = results.rows.item(0).NUM_CORRIDA;

                var data = ProService.FormatDataRastreamento(new Date());
                //3-inserir na TB_RASTREAMENTO
                $rootScope.db.insert("TB_RASTREAMENTO", { Unidade: localStorageService.get('Usuario').NumUnidade, DataHora: data, Latitude: lat, Longitude: lon, AtendimentoID: $rootScope.AtendimentoID, ATIVO: 'N' }).then(function (results) { 
                	console.log('INSERINDO NO BANCO');
                });
                $rootScope.Processando = false;
            });
    }

    /*function AddPositionFunction() {
        //console.log("Entrou AddPosition Function " + posit);
        var posit = 1;
        var currentUpdate, lastUpdate;
        $rootScope.db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        if (!$rootScope.db) { console.log('Database not created!'); } else {
            var options = { maximumAge: 0, timeout: 5000, enableHighAccuracy: true };
            //console.log("Rastrear 01");
            navigator.geolocation.getCurrentPosition(onSucessoGPS, onErrorGPS, options);
        }
        $rootScope.AddPositionTimeOut = $timeout(AddPositionFunction, 20000);
        //console.log("$rootScope.AddPositionTimeOut", $rootScope.AddPositionTimeOut);
    }*/
    
    function AddPositionFunction() {
        console.log("Entrou AddPosition Function " + posit);
        var posit = 1;
        var currentUpdate, lastUpdate;
        $rootScope.db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        if (!$rootScope.db) { console.log('Database not created!'); } else {
            var options = { maximumAge: 3000, timeout: 10000, enableHighAccuracy: true };
            //console.log("Rastrear 01");
            $rootScope.watchID = navigator.geolocation.watchPosition(onSucessoGPS, onErrorGPS, options);
            console.log($rootScope.watchID);
        }
       // $rootScope.AddPositionTimeOut = $timeout(AddPositionFunction, 20000);
        //console.log("$rootScope.AddPositionTimeOut", $rootScope.AddPositionTimeOut);
    }

    function EnviarRastreamentoWS() {
        //console.log("Entrou EnviarRastreamentoWS ");

        $rootScope.posicoes = [];
        $rootScope.db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        $rootScope.db.select("TB_RASTREAMENTO", {
            "Ativo": {
                "value": 'N'
            }
        }).then(function (results) {
            //console.log("Montar array de rastreamento...");
            //Objeto literal que será usado no JSON
            var objJSON = {};

            for (i = 0; i < results.rows.length; i++) {
                objJSON = {AtendimentoID:'', Unidade: '', DataHora: '', Latitude: '', Longitude: '', Velocidade: '', Sentido: '' };

                objJSON.AtendimentoID = !!results.rows.item(i).AtendimentoID ? Number(results.rows.item(i).AtendimentoID) : 0;
                objJSON.Unidade = !!results.rows.item(i).Unidade ? String(results.rows.item(i).Unidade) : '';
                objJSON.DataHora = !!results.rows.item(i).DataHora ? results.rows.item(i).DataHora : '';
                objJSON.Latitude = !!results.rows.item(i).Latitude ? results.rows.item(i).Latitude : '';
                objJSON.Longitude = !!results.rows.item(i).Longitude ? results.rows.item(i).Longitude : '';
                objJSON.Velocidade = "0"//!!results.rows.item(i).Velocidade? results.rows.item(i).Velocidade: '';
                objJSON.Sentido = !!results.rows.item(i).Sentido ? results.rows.item(i).Sentido : '';
                $rootScope.posicoes.push(objJSON);
            }
            //console.log("Montar dados para envio...");
            $rootScope.metodoEnviaRastreamento = 'Navegacao';

            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoEnviaRastreamento;
            var _json = { "CNPJ": localStorageService.get('Licenciada').CNPJ, "versaoAPP": $rootScope.versaoAPP, "macAddr": $rootScope.numMAC, "ListaNavegacao": $rootScope.posicoes };
            //console.log("json:" + JSON.stringify(_json));
            //console.log("rastreamento URL:" + _url);
            $http(
            {
                method: "POST",
                url: _url,
                data: _json
            })
            .error(function (error) {
                console.log('Error: ' + error);
            })
            .success(function (callback) {
            	console.log('Envio WebService');
                if (callback.CodigoRetorno === 0) {
                    for (var i = 0; i < $rootScope.posicoes.length; i++) {
                        $rootScope.db.del("TB_RASTREAMENTO", { "DataHora": $rootScope.posicoes[i].DataHora });
                        //console.log("Arquivo Excluido: " + $rootScope.posicoes[i].DataHora);
                    }
                }
                //console.log("callback Rastreamento: " + JSON.stringify(callback));
                angular.forEach(callback, function (value, key) {
                    //console.log('Sucesso: ' + key + ': ' + value);
                }, null);                    
            });
        });
        //Retirar comentário
        $rootScope.EnviarRastreamentoID = $timeout(EnviarRastreamentoWS, 20000);
    }

    function DistanciaDoisPontosGPS(lat1, lon1, lat2, lon2) {
        var R = 6371; // km
        var φ1 = lat1.toRadians();
        var φ2 = lat2.toRadians();
        var Δφ = (lat2 - lat1).toRadians();
        var Δλ = (lon2 - lon1).toRadians();

        var a = Math.sin(Δφ / 2) * Math.sin(Δφ / 2) + Math.cos(φ1) * Math.cos(φ2) * Math.sin(Δλ / 2) * Math.sin(Δλ / 2);
        var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));

        var d = R * c;

        return d;
    }

    return {
        GetLatitudeLongitude: function (callback) {
            var options = { maximumAge: 0, timeout: 10000, enableHighAccuracy: true };
            navigator.geolocation.getCurrentPosition(onSucessoGPS, onErrorGPS, options);
            console.log('????????????????????????????');
        },
        onErrorGPS: function (code) {
            if (code == 1)
                return 'Usuário negou a conexão com GPS.';
            else if (code == 2)
                return 'Nenhuma conexão com GPS.';
            else
                return 'Tempo esgotado na conexão com GPS .';
        },
        AddPosition: function () {
            AddPositionFunction();
        },
        EnvioRastreamento: function () {
            EnviarRastreamentoWS();
        },
    }
});