﻿angular.module('Solus.MensagensService', [])

.factory('MensagensService', function ($http, $webSql, $rootScope, $ionicPopup, $timeout, ProService, localStorageService) {

    function listaMensagem(callback) {
        console.log("Buscando Mensagens...");
        //Somente ir buscar nova corrida se tabela CORRIDA estiver vazia. 
        $rootScope.metodoListaMensagens = "ListaMensagens";
        var url = localStorageService.get('Config').UrlServico + $rootScope.metodoListaMensagens + '/' + localStorageService.get('Usuario').versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ + '/' + localStorageService.get('Usuario').NumUnidade;
        console.log("_url...", url);
        $http(
            {
                method: "GET",
                url: url,
                //headers: { 'Content-Type': 'application/json; charset=utf-8' }
            })
                .error(function (error) {
                    console.log('Error: ' + error);
                }
                )
                .success(function (callback) {

                    if (callback.CodigoRetorno == "0") {
                        if (callback.Itens.length > 0) {
                            console.log($rootScope.listaMensagens);
                            $rootScope.db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);

                            if (callback.Itens.length > 1) {
                                for (var i = 0; i < callback.Itens.length; i++) {
                                    $rootScope.db.insert("TB_MENSAGEM", { ID: callback.Itens[i].MensagemID, DATA: callback.Itens[i].Data, DSC_MENSAGEM: callback.Itens[i].Mensagem }).then(function (results) {
                                    });
                                }
                            } else {
                                $rootScope.db.insert("TB_MENSAGEM", { ID: callback.Itens[0].MensagemID, DATA: callback.Itens[0].Data, DSC_MENSAGEM: callback.Itens[0].Mensagem }).then(function (results) {
                                });
                            }
                        }
                    }

                })
        $rootScope.db.select("TB_MENSAGEM", {
            "ID": {
                "value": 'IS NOT NULL'
            }
        }).then(function (results) {
            if (results.rows.length > 0) {
                $rootScope.listaMensagens = [];
                for (var i = 0; i < results.rows.length; i++) {
                    $rootScope.listaMensagens.push(results.rows.item(i));
                }
                console.log('listaMensagens', $rootScope.listaMensagens);
            }

        })
        $timeout(listaMensagem, 60000);
    }


    return {
        ListarMensagens: function (callback) {
            listaMensagem(callback);
        },

        ListaTiposMensagens: function () {
            $rootScope.metodoListaTiposMensagens = "ListaTiposMensagens";
            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoListaTiposMensagens + '/' + localStorageService.get('Usuario').versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ;
            $http({
                method: "GET",
                url: _url
            })
            .error(function (error) {
                console.log('Error: ' + error);

                //Mostrar Erro
                var alertPopup = $ionicPopup.alert({
                    title: 'Carregar tipos de mensagem',
                    template: 'Não foi possível carregar tipos de mensagem.'
                });
            })
            .success(function (callback) {
                if (callback.CodigoRetorno == "0") {
                    if (callback.Itens.length > 0) {

                        angular.forEach(callback.Itens, function (campos, key) {
                            //console.log("Campos Mensagens", JSON.stringify(campos));
                            $rootScope.db.insert("TB_TIPO_MENSAGEM", campos).then(function (results) { });
                        });
                        $rootScope.tiposMensagem = callback.Itens;
                        //$rootScope.tiposMensagem = callback.Itens;
                        //console.log("Retorno Tipos Mensagens", JSON.stringify(callback));
                    }
                }

            })
        },

        EnviaMensagemUnidade: function (callback) {
            $rootScope.metodoEnviaMensagemUnidade = 'EnviaMensagemUnidade';
            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoEnviaMensagemUnidade;// + "/" + $rootScope.versaoAPP + "/" + $rootScope.numMAC;
            var objMensagem = { versaoApp: '', macAddr: '', CNPJ: '', AtendimentoID: '', MensagemID: '', DataHora: '', Unidade: '', Latitude: '', Longitude: '', StatusAtual: '' };
            objMensagem.versaoApp = $rootScope.versaoAPP;
            objMensagem.macAddr = $rootScope.numMAC;
            objMensagem.CNPJ = $rootScope.NumCnpj;
            objMensagem.AtendimentoID = $rootScope.AtendimentoID;
            objMensagem.MensagemID = $rootScope.mensagemID;
            objMensagem.DataHora = ProService.FormatDataRastreamento(new Date());
            objMensagem.Unidade = $rootScope.NumUnidade;
            objMensagem.Latitude = $rootScope.Latitude;
            objMensagem.Longitude = $rootScope.Longitude;
            objMensagem.StatusAtual = $rootScope.StatusUnidade;
            console.log('_url', _url);
            console.log('objMensagem ', JSON.stringify(objMensagem));
            $http(
            {
                method: "POST",
                url: _url,
                data: objMensagem
            })
            .error(function (error) {
                //Mostrar Erro
                var alertPopup = $ionicPopup.alert({
                    title: 'Envio de mensagem',
                    template: 'Não foi possível enviar mensagem.'
                });
            })
            .success(function (data, status, headers, config) {
                console.log("data", JSON.stringify(data));
                var alertPopup = $ionicPopup.alert({
                    title: 'Envio de mensagem',
                    template: 'Mensagem enviada com sucesso.<br/>' + $rootScope.mensagemID + ' - ' + $rootScope.mensagemDescricao
                });
            });
        }
    }
});