﻿angular.module('Taxi2.RegistroDispositivoService', [])

.factory('RegistroDispositivoService', function ($http, $rootScope, $q, localStorageService) {

    var asyncService = {};

    asyncService.BuscaUnidadeMac = function () {
        var _url = localStorageService.get('Config').UrlServico + localStorageService.get('Metodos').BuscaUnidadeMac + '/' + $rootScope.versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ;
        console.log('URL BuscaUnidadeMac', _url);
        var deffered = $q.defer();
        $http.get(_url)
        .success(function (d) {
            console.log(d);
            deffered.resolve(d);
        })
        .error(function (e) {
            deffered.reject(e);
        });
        return deffered.promise;
    };

    asyncService.ListarStatus = function () {
        //Limpando dados de status
        $rootScope.status = [];
        $rootScope.db.del("TB_STATUS", { "COD_STATUS": { "value": 'IS NOT NULL' } });

        $rootScope.metodoListaStatus = 'ListaStatus';
        var _urlStatus = localStorageService.get('Config').UrlServico + $rootScope.metodoListaStatus + '/' + $rootScope.versaoAPP + '/' + $rootScope.numMAC + '/' + $rootScope.NumCnpj;
        //console.log("_url ListaStatus", _urlStatus);
        $http(
        {
            method: "GET",
            url: _urlStatus
        })
        .error(function (error) {
            console.log('Error: ' + error);
            $rootScope.mensagemErro = 'error: Status não listados';
        })
        .success(function (data, status, headers, config) {
            if (data.CodigoRetorno == "1") {
                //console.log('Error: ' + data.erro);
                $rootScope.mensagemErro = data.erro;
            } else {
                for (var i = 0; i < data.Itens.length; i++) {
                    $rootScope.status[i] = data.Itens[i];
                    $rootScope.db.insert("TB_STATUS", {
                        'COD_STATUS': $rootScope.status[i].Codigo,
                        'DSC_STATUS': $rootScope.status[i].Descricao,
                        'FLG_INICIA': $rootScope.status[i].Inicia,
                        'FLG_FINALIZA': $rootScope.status[i].Finaliza,
                        'DSC_PROXIMOS_STATUS': $rootScope.status[i].ProximosStatus
                    }).then(function (results) {
                    });
                }
                //console.log($rootScope.status);
            }
        })
    };

    return asyncService;
});