﻿angular.module('Solus.StatusService', [])

SolusApp.factory('StatusService', function ($http, $webSql, $rootScope, ProService, $ionicPopup, $timeout, $q, localStorageService) {

    /*
   MÉTODO QUE CARREGA OS STATUS A PARTIR DO WEB SERVICE
   */
    function CarregarStatusServer() {
        //Limpando dados de status
        $rootScope.status = [];
        $rootScope.db.del("TB_STATUS", { "COD_STATUS": { "value": 'IS NOT NULL' } });

        var _urlStatus = localStorageService.get('Config').UrlServico + localStorageService.get('Metodos').ListaStatus + '/' + $rootScope.versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ;
        //console.log("_url ListaStatus", _urlStatus);
        $http(
        {
            method: "GET",
            url: _urlStatus
        })
        .error(function (error) {
            console.log('Error: ' + error);
            $rootScope.mensagemErro = 'error: Status não listados';
        })
        .success(function (data, status, headers, config) {
            if (data.CodigoRetorno == "1") {
                //console.log('Error: ' + data.erro);
                $rootScope.mensagemErro = data.erro;
            } else {
                for (var i = 0; i < data.Itens.length; i++) {
                    $rootScope.status[i] = data.Itens[i];
                    $rootScope.db.insert("TB_STATUS", {
                        'COD_STATUS': $rootScope.status[i].Codigo,
                        'DSC_STATUS': $rootScope.status[i].Descricao,
                        'FLG_INICIA': $rootScope.status[i].Inicia,
                        'FLG_FINALIZA': $rootScope.status[i].Finaliza,
                        'DSC_PROXIMOS_STATUS': $rootScope.status[i].ProximosStatus
                    }).then(function (results) {
                    });
                }
                //console.log($rootScope.status);
            }
        })

    }

    return {

        CarregarStatus: function(){
            CarregarStatusServer();
        },
        AtualizarStatus: function (callback) {
            //Montando url do serviço
            $rootScope.DataHora = ProService.FormatDataRastreamento(new Date());
            var _url = localStorageService.get('Config').UrlServico + $rootScope.metodoAtualizaStatus;
            console.log("Dados AtualizarStatus _url: ", _url);
            if ($rootScope.NovoStatusUnidade == undefined) {
                $rootScope.NovoStatusUnidade = $rootScope.StatusUnidade;
            }
            //1-Inserir registro off line CORRIDA_ACOMPANHAMENTO
            var objAtendimento = { DATA: ProService.FormatDataRastreamento(new Date()), COD_STATUS: $rootScope.NovoStatusUnidade, NUM_ATENDIMENTO: $rootScope.AtendimentoID, LATITUDE: $rootScope.Latitude, LONGITUDE: $rootScope.Longitude, FLG_ENVIADO: 'N' };
            //console.log("objAtendimento AtualizarStatus", JSON.stringify(objAtendimento));
            $rootScope.db.insert("TB_CORRIDA_ATENDIMENTO", objAtendimento).then(function (results) { });
            //Alterando o status
            $rootScope.StatusUnidade = $rootScope.NovoStatusUnidade;
            verificaFlag($rootScope.NovoStatusUnidade);
            //Alterando tabela configurações
            $rootScope.db.update("TB_CONFIGURACOES", { "COD_STATUS_UNIDADE": $rootScope.NovoStatusUnidade }, { 'id': 1 });
            //2-Listar todos os registro ainda não enviados FLG_ENVIADO = 'N'
            $rootScope.db.select("TB_CORRIDA_ATENDIMENTO", {
                "FLG_ENVIADO": {
                    "value": 'N'
                }
            }).then(function (results) {
                //3-Percorrer a listagem dos itens do results e chamar o webservice
                for (var i = 0; i < results.rows.length; i++) {
                    var _id = results.rows.item(i).ID;
                    //console.log('id ATENDIMENTO inicio', _id);
                    var _data = results.rows.item(i).DATA;
                    var _dados = JSON.parse('{ "versaoApp ": "' + $rootScope.versaoAPP + '", "cnpj": "' +
                        localStorageService.get('Licenciada').CNPJ + '", "macAddr": "' + $rootScope.numMAC + '", "unidade": "' +
                        localStorageService.get('Usuario').NumUnidade + '", "status": "' + results.rows.item(i).COD_STATUS + '", "atendimentoID": "' +
                        results.rows.item(i).NUM_ATENDIMENTO + '", "Latitude": "' + results.rows.item(i).LATITUDE + '", "Longitude": "' +
                        results.rows.item(i).LONGITUDE + '", "Velocidade": "' + $rootScope.Velocidade + '", "DataHora": "' + _data + '" }');
                    console.log("Dados AtualizarStatus: ", JSON.stringify(_dados));
                    //Tentar atualizar o servidor
                    var deferred = $q.defer();
                    $http({
                        method: "POST",
                        data: _dados,
                        url: _url
                    })
                    .error(function (error) {
                        //console.log('Error: ' + error);
                        deferred.reject();
                    })
                    .success(function (callback) {
                        //console.log("callback", callback);
                        //console.log('id ATENDIMENTO fim', _id);
                        if (callback.CodigoRetorno == "0") {
                            //Atualizando
                            $rootScope.db.update("TB_CORRIDA_ATENDIMENTO", { "FLG_ENVIADO": "S" }, { 'ID': _id });
                        }
                        deferred.resolve(callback);
                    });
                }
                //4-Atualizar status para enviado
            });
            //5-Atualizar a listagem de próximos status a partir do último registro de status
            proximosStatusCorrida();
            //Atualizar 
            listaAtendimentoNaoEnviado();


            //var _dados = JSON.parse('{ "versaoApp ": "' + $rootScope.versaoAPP + '", "cnpj": "' +
            //    localStorageService.get('Licenciada').CNPJ + '", "macAddr": "' + $rootScope.numMAC + '", "unidade": "' +
            //    $rootScope.NumUnidade + '", "status": "' + $rootScope.NovoStatusUnidade + '", "atendimentoID": "' +
            //    $rootScope.AtendimentoID + '", "Latitude": "' + $rootScope.Latitude + '", "Longitude": "' +
            //    $rootScope.Longitude + '", "Velocidade": "' + $rootScope.Velocidade + '", "DataHora": "' + $rootScope.DataHora + '" }');

            //console.log("Dados AtualizarStatus: ", JSON.stringify(_dados));

            //$http(
            //{
            //    method: "POST",
            //    data: _dados,
            //    url: _url
            //})
            //.error(function (error) {
            //    console.log('Error: ' + error);
            //})
            //.success(function (callback) {
            //    console.log("callback", callback);
            //    if (callback.CodigoRetorno == "0") {
            //        $rootScope.db.update("TB_CONFIGURACOES", { "COD_STATUS_UNIDADE": $rootScope.NovoStatusUnidade }, {'id': 1});
            //        var CorridaAtendimentoJSON = { DATA: '', COD_STATUS: '', NUM_ATENDIMENTO: '', LATITUDE: '', LONGITUDE: '', FLG_ENVIADO: 'S' };
            //        CorridaAtendimentoJSON.DATA = $rootScope.DataHora;
            //        CorridaAtendimentoJSON.COD_STATUS = $rootScope.NovoStatusUnidade;
            //        CorridaAtendimentoJSON.NUM_ATENDIMENTO = $rootScope.AtendimentoID;
            //        $rootScope.db.insert("TB_CORRIDA_ATENDIMENTO", CorridaAtendimentoJSON).then(function (results) {
            //        });
            //        
            //        $rootScope.proximosStatus = [];


            //        angular.forEach(callback.Itens, function (campos, key) {
            //            objJSON = { Codigo: '', Descricao: '' };
            //            objJSON.Codigo = campos["Codigo"];
            //            objJSON.Descricao = campos["Descricao"];
            //            $rootScope.proximosStatus.push(objJSON);
            //        }, null);


            //        console.log('Proximos status', $rootScope.proximosStatus);
            //        $rootScope.StatusUnidade = CorridaAtendimentoJSON.COD_STATUS;
            //        pegaDescricaoStatus($rootScope.StatusUnidade);
            //    }
            //})
        },
        BuscaProximosStatus: function (callback) {
            proximosStatusCorrida();
            //console.log("valor do status", $rootScope.StatusUnidade);
            ////5-Atualizar a listagem de próximos status a partir do último registro de status
            //$rootScope.db.select("TB_STATUS", {
            //    "COD_STATUS": {
            //        "value": $rootScope.StatusUnidade
            //    }
            //}).then(function (results) {
            //    var CodProximosStatus = results.rows.item(0).DSC_PROXIMOS_STATUS.split(",");
            //    $rootScope.db.selectAll("TB_STATUS").then(function (results2) {
            //        $rootScope.proximosStatus = [];
            //        for (var i = 0; i < results2.rows.length; i++) {
            //            CodProximosStatus.forEach(function (value, index, array) {
            //                // here value is the array element being iterated
            //                if (value.trim() == results2.rows.item(i).COD_STATUS)
            //                {
            //                    objJSON = { Codigo: '', Descricao: '' };
            //                    objJSON.Codigo = results2.rows.item(i).COD_STATUS;
            //                    objJSON.Descricao = results2.rows.item(i).DSC_STATUS;
            //                    $rootScope.proximosStatus.push(objJSON);
            //                    console.log("Status", value);
            //                } 
            //            });
            //        }
            //    });
            //});
        },
        ListaStatusNaoEnviado: function (callback) {
            listaAtendimentoNaoEnviado();
        }
    };

    function pegaDescricaoStatus(Codstatus) {
        var db;
        db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        db.select("TB_STATUS", {
            "COD_STATUS": {
                "value": $rootScope.StatusUnidade
            }
        }).then(function (results) {
            if (results.rows.length > 0)
                $rootScope.DescricaoStatusUnidade = results.rows.item(0).DSC_STATUS;
        })
    }

    function verificaFlag(callback) {
        var db;
        db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        
        db.select("TB_STATUS", {
            "COD_STATUS": {
                "value": $rootScope.NovoStatusUnidade
            }
        }).then(function (results) {
            if (results.rows.length > 0) {
                $rootScope.FlagInicia = results.rows.item(0).FLG_INICIA;
                $rootScope.FlagFinaliza = results.rows.item(0).FLG_FINALIZA;
                //console.log("$rootScope.FlagFinaliza", $rootScope.FlagFinaliza);
                if ($rootScope.FlagFinaliza == 'S') {
                    deletarCorrida();
                }
            }
        })
    }
    
    
    function deletarCorrida() {
        var db;
        db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        $rootScope.db.del("TB_CORRIDA", {
            "NUM_CORRIDA": {
                "value": 'IS NOT NULL'
            }
        });
        //Corrida 
        localStorageService.set('Corrida', { Ativo: 'false', Dados: '[]' });
        localStorageService.set('CorridaGeral', { Ativo: 'false', Dados: '[]' });
        $rootScope.Corrida = JSON.parse(localStorageService.get('Corrida').Dados);
        $rootScope.CorridaGeral = JSON.parse(localStorageService.get('Corrida').Dados);
        $rootScope.CorridaAtiva = localStorageService.get('Corrida').Ativo;
        $rootScope.dadosCorrida = [];
        $rootScope.AtendimentoID = 0;
        //Forçar unidade Livre após encerrar
        localStorageService.set('Unidade', { Status: 'LI', DescricaoStatus: 'Livre' });
        SetarUnidadeFunction();
    }

    function SetarUnidadeFunction() {
        $rootScope.Unidade = { NumUnidade: localStorageService.get('Usuario').NumUnidade, Status: localStorageService.get('Unidade').Status, DescricaoStatus: localStorageService.get('Unidade').DescricaoStatus };
    };

    function proximosStatusCorrida() {
        //console.log("valor do status", $rootScope.StatusUnidade);
        //5-Atualizar a listagem de próximos status a partir do último registro de status
        $rootScope.db.select("TB_STATUS", {
            "COD_STATUS": {
                "value": $rootScope.StatusUnidade
            }
        }).then(function (results) {
            var CodProximosStatus = results.rows.item(0).DSC_PROXIMOS_STATUS.split(",");
            $rootScope.db.selectAll("TB_STATUS").then(function (results2) {
                $rootScope.proximosStatus = [];
                for (var i = 0; i < results2.rows.length; i++) {
                    CodProximosStatus.forEach(function (value, index, array) {
                        // here value is the array element being iterated
                        if (value.trim() == results2.rows.item(i).COD_STATUS) {
                            objJSON = { Codigo: '', Descricao: '' };
                            objJSON.Codigo = results2.rows.item(i).COD_STATUS;
                            objJSON.Descricao = results2.rows.item(i).DSC_STATUS;
                            $rootScope.proximosStatus.push(objJSON);
                            //console.log("Status", value);
                        }
                    });
                }
            });
        });
        listaAtendimentoNaoEnviado();
    }

    function listaAtendimentoNaoEnviado() {
        var db;
        db = $webSql.openDatabase('Solus', '1.0', 'Database Solus', 200000);
        $rootScope.atendimentoNaoEnviado = 0;
        db.select("TB_CORRIDA_ATENDIMENTO", {
            "FLG_ENVIADO": {
                "value": 'N'
            }
        }).then(function (results) {
            $rootScope.atendimentoNaoEnviado = results.rows.length;
            //console.log("quantidade de registros", results.rows.length);
        })
    }
});
