angular.module('Solus.TabCorridasService', [])

.factory('TabCorridasService', function ($http, $rootScope, $q, ProService, localStorageService) {
    
	var asyncService = {};

	
	asyncService.listarCorridas = function(){
		
		var versaoAPP = localStorageService.get('Usuario').versaoAPP;
		
		var url = localStorageService.get('Config').UrlServico + 'ListaCorridasAgendadas' + '/' + versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ;
		console.log('URL CORRIDAS', url);
		
		var deffered = $q.defer();
		
		$http.get(url).success(function(data) {
			var i = 0;
			angular.forEach(data.Corridas, function (item) {
                            data.Corridas[i].NovaData = ProService.FormatDateTimeBrasil(item.DataHoraProgramacao);
                            i = i + 1;
                        });
			deffered.resolve(data);
			//console.log('DATA', data);
			
			}).error(function(data) {
			
			deffered.reject(data);
			console.log(data);
		});
		return deffered.promise;
	}
	
	asyncService.listarCorridasDisponiveis = function(){
		
		var versaoAPP = localStorageService.get('Usuario').versaoAPP;
		
		var url = localStorageService.get('Config').UrlServico + 'listaCorridasDisponiveis' + '/' + versaoAPP + '/' + $rootScope.numMAC + '/' + localStorageService.get('Licenciada').CNPJ;
		console.log('URL CORRIDAS', url);
		
		var deffered = $q.defer();
		
		$http.get(url).success(function(data) {
			
			deffered.resolve(data);
			console.log('DATA', data);
			
			}).error(function(data) {
			
			deffered.reject(data);
			console.log(data);
		});
		return deffered.promise;
	}

	asyncService.confirmarCorrida = function(atendimento){
		
		var versaoAPP = localStorageService.get('Usuario').versaoAPP;
		
		var url = localStorageService.get('Config').UrlServico + 'ConfirmaRecebimento';
		var deffered = $q.defer();
		var dados = {};
		dados.unidade = localStorageService.get('Usuario').NumUnidade;
        dados.cnpj = localStorageService.get('Licenciada').CNPJ;
        dados.versaoApp = versaoAPP;
        dados.status = "CA";
        dados.atendimentoID = atendimento.CorridaDespachoID;
        dados.DataHora = ProService.FormatDataRastreamento(new Date());
        dados.Latitude = $rootScope.Latitude;// "-3.75167439636291";
        dados.Longitude = $rootScope.Longitude;// "-38.503193227901";
        dados.macAddr = $rootScope.numMAC;// Geral.NetWorkMac();
		
		$http.post(url, dados).success(function(data) {
			
			deffered.resolve(data);
			console.log('Confirmar corrida', data);
			
			}).error(function(data) {
			
			deffered.reject(data);
			console.log(data);
		});
		return deffered.promise;
	}

	
	return asyncService;
   
	
});