// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
var SolusApp = angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'starter.websql', 'Solus.CorridaService', 'Solus.ConfiguracoesService', 'angular-websql', 'Solus.MensagensController',
    'Solus.MensagensService', 'GPR.ProService', 'Solus.GpsService', 'Solus.ConfiguracoesController', 'Solus.LoginService', 'Solus.StatusService', 'Solus.RegistroDispositivoController', 'db.Service',
    'Solus.SplashService', 'LocalStorageModule', 'app.AdministracaoService', 'Taxi2.RegistroDispositivoService', 'Taxi2.UnidadeService', 'starter.directives', 'Solus.TabCorridasService', 'Solus.TabCorridaController', 'VoucherService'])

//.run(function ($ionicPlatform, $location, $rootScope) {
.run(function ($ionicPlatform, GpsService) {
    $ionicPlatform.ready(function () {
    	console.log('ON DEVICE READY!!!!!!!!!!!!!!!!!!');
    	//GpsService.AddPosition(function () { });
        //onDeviceReady();
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
    //consultarConfiguracoes($location, $rootScope);
    onDeviceReady();
  });
})

.config(function (localStorageServiceProvider) {
    localStorageServiceProvider
      .setNotify(true, true)
      .setPrefix('Taxi2');
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js

    //$stateProvider
    //.state('login', {
    //    url: '/login',
    //    templateUrl: 'templates/login.html'
    //})

    $stateProvider
        .state('registroDispositivo', {
            url: '/registroDispositivo',
            templateUrl: 'templates/registroDispositivo.html',
            controller: 'PopupRegistroDispositivoCtrl'
        })

        .state('splash', {
            url: '/splash',
            templateUrl: 'templates/splash.html',
            controller: 'SplashCtrl'
        })
    // setup an abstract state for the tabs directive
    .state('tab', {
      url: "/tab",
      abstract: true,
      templateUrl: "templates/tabs.html"
    })

    // Each tab has its own nav history stack:

    .state('status', {
        url: '/status',
                templateUrl: 'templates/status.html',
                controller: 'StatusController'
    })

    .state('tab.dash', {
      url: '/dash',
      views: {
        'tab-dash': {
          templateUrl: 'templates/tab-dash.html',
          controller: 'CorridaCTRL'
        }
      }
    })

    .state('tab.mensagens', {
      url: '/mensagens',
      views: {
        'tab-mensagens': {
          templateUrl: 'templates/tab-mensagens.html',
          controller: 'MensagemCtrl'
        }
      }
    })
    .state('tab.friend-detail', {
      url: '/friend/:friendId',
      views: {
        'tab-friends': {
          templateUrl: 'templates/friend-detail.html',
          controller: 'FriendDetailCtrl'
        }
      }
    })
        .state('tab.listaMensagens', {
            url: '/listaMensagens',
            views: {
                'tab-listaMensagens': {
                    templateUrl: 'templates/tab-listaMensagens.html',
                    controller: 'FriendCtrl'
                }
            }
        })

    .state('tab.account', {
      url: '/account',
      views: {
        'tab-account': {
          templateUrl: 'templates/account.html',
          controller: 'AccountCtrl'
        }
      }
    })

    .state('tab.configuracoes', {
        url: '/configuracoes',
        views: {
            'tab-configuracoes': {
                templateUrl: 'templates/tab-configuracoes.html',
                controller: 'ConfiguracoesCtrl'
            }
        }
    })
    
    
    .state('tab.corridas', {
        url: '/corridas',
        views: {
            'tab-corridas': {
                templateUrl: 'templates/corridas.html',
                controller: 'TabCorridaController as TabCorridaCtrl'
            }
        }
    })
    
    .state('tab.mapa', {
        url: '/mapa',
        views: {
            'tab-mapa': {
                templateUrl: 'templates/tab-mapa.html',
                controller: 'MapCtrl'
            }
        }
    });

  // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/splash');

});

document.addEventListener("deviceready", onDeviceReady, false);
var options = { maximumAge: 0, timeout: 10000, enableHighAccuracy: true };
var numDispositivo;
function onDeviceReady() {
    createDB();
}