angular.module('starter.websql', [])
var db = 0;
var versaoDB = "1.0";

function createDB() {
    if (!db) {
        db = openDatabase("Solus", versaoDB, "Database Solus", 200000);
        //console.log("db no existe");
    }
    db.transaction(populateDB, errorCB, sucessCreateCB);
}


function populateDB(tx) {
    
    
    db.transaction(function (tx) {
        //Drop tables
        //tx.executeSql('DROP TABLE IF EXISTS TB_CONFIGURACOES');
        //tx.executeSql('DROP TABLE IF EXISTS TB_RASTREAMENTO');
        //tx.executeSql('DROP TABLE IF EXISTS TB_CORRIDA');
        //tx.executeSql('DROP TABLE IF EXISTS TB_CORRIDA_ATENDIMENTO');
        //tx.executeSql('DROP TABLE IF EXISTS TB_STATUS');
        //tx.executeSql('DROP TABLE IF EXISTS TB_TIPO_MENSAGEM');
        //Tabela de Configuraes
        tx.executeSql('CREATE TABLE IF NOT EXISTS TB_CONFIGURACOES(ID INTEGER, DSC_URL TEXT, FLG_ATIVO TEXT(1), NUM_CNPJ_LICENCIADA TEXT, DSC_NOME_LICENCIADA TEXT, ID_USUARIO INTEGER, DSC_NOME TEXT, NUM_UNIDADE TEXT, DSC_MODELO_UNIDADE TEXT, NUM_TIME_GPS INTEGER, DSC_VERSAO_WS TEXT, COD_STATUS_UNIDADE TEXT, DSC_LOGO_LICENCIADA TEXT, FLG_DEMO TEXT, DSC_VERSAO_APP TEXT)', []);
        //Tabela de rastreamento
        tx.executeSql("CREATE TABLE IF NOT EXISTS TB_RASTREAMENTO(Unidade TEXT, DataHora NUMERIC, Latitude TEXT, Longitude TEXT, Ativo TEXT, AtendimentoID INTEGER, Velocidade INTEGER, Sentido TEXT Default 'SN')", []);
        //Tabela de Tipo de Mensagem
        tx.executeSql("CREATE TABLE IF NOT EXISTS TB_TIPO_MENSAGEM (MensagemID INTEGER PRIMARY KEY ASC, Mensagem TEXT, Data TEXT )", []);
        //Tabela de Mensagem
        tx.executeSql("CREATE TABLE IF NOT EXISTS TB_MENSAGEM (ID INTEGER PRIMARY KEY, DATA TEXT, DSC_MENSAGEM TEXT )", []);
        //Tabela de Status
        tx.executeSql("CREATE TABLE IF NOT EXISTS TB_STATUS (COD_STATUS TEXT PRIMARY KEY, DSC_STATUS TEXT, DSC_PROXIMOS_STATUS TEXT, FLG_INICIA TEXT, FLG_FINALIZA TEXT)", []);
        //Tabela de Corrida
        tx.executeSql("CREATE TABLE IF NOT EXISTS TB_CORRIDA (NUM_CORRIDA INTEGER, NUM_UNIDADE TEXT, DSC_ENDERECO TEXT,DSC_PONTO_REFERENCIA TEXT,DSC_PASSAGEIRO TEXT,DAT_CORRIDA TEXT, DSC_CONTATO TEXT, DSC_TELEFONE TEXT,DSC_TIPO_ATENDIMENTO TEXT, DSC_OBSERVACAO TEXT, LATITUDE TEXT, LONGITUDE TEXT, COD_STATUS TEXT, FLG_CONFIRMADO TEXT(1), FLG_SEXO_PACIENTE TEXT(1), DSC_FORMA_PAGAMENTO TEXT, NUM_IDADE TEXT, NUM_TEMPO_SINTOMAS TEXT, DSC_SINTOMAS TEXT, DSC_RETORNO_WS TEXT)", []);
        //Tabela de Corrida Atendimento
        tx.executeSql("CREATE TABLE IF NOT EXISTS TB_CORRIDA_ATENDIMENTO (ID INTEGER PRIMARY KEY,DATA TEXT, COD_STATUS TEXT, NUM_ATENDIMENTO INTEGER, LATITUDE TEXT, LONGITUDE TEXT, FLG_ENVIADO TEXT(1))", []);
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM TB_CONFIGURACOES WHERE ID = 1', [], function (tx, results) {
                var len = results.rows.length, i;
                if (len === 0) {
                    var scriptSQL = 'INSERT INTO TB_CONFIGURACOES(ID, DSC_URL, FLG_ATIVO, NUM_CNPJ_LICENCIADA, DSC_NOME_LICENCIADA, ID_USUARIO, DSC_NOME, NUM_UNIDADE, DSC_MODELO_UNIDADE, NUM_TIME_GPS, COD_STATUS_UNIDADE, DSC_VERSAO_APP) VALUES (1,"http://gprti.no-ip.info/wssolus/wsSolus.svc/","N",null,"",null,null,"",null,20000,"D","1.0.20")';
                    tx.executeSql(scriptSQL, [], function (tx, results) { }, null);
                }
            }, null);
        });
    });
}

function errorCB(err) {
    console.log("Error processing SQL:" + err.code);
}

function sucessCreateCB() {
    console.log("Database has been created successfully");
}

function consultarConfiguracoes($location, $rootScope, $timeout) {
    db.transaction(function (tx) {
        tx.executeSql('SELECT * FROM TB_CONFIGURACOES', [], function (tx, results) {
            var len = results.rows.length;
            if (len == 0) {
                //alert('Dispositivo nao registrado!');
                $location.path('/registroDispositivo');
            }
            else {                
                //$rootScope.versaoAPP = '20143010'; 
                $rootScope.UrlService = results.rows.item(0).DSC_URL;
                $rootScope.tempoAtualizacao = results.rows.item(0).NUM_TIME_GPS;
                //console.log("$rootScope.UrlService", $rootScope.UrlService);
                //Se estiver logado vai direto para tela principal
                //console.log("results.rows.item(0).FLG_ATIVO ", results.rows.item(0).DSC_NOME == '');
                //$timeout.cancel($rootScope.AddPositionTimeOut);
                if ((results.rows.item(0).FLG_ATIVO == "S") && (results.rows.item(0).DSC_NOME != "")) {
                    $location.path('/tab/dash');
                }
                //Somente vai para o login se tiver ativo
                else if (results.rows.item(0).FLG_ATIVO == "S")
                    $location.path('/login');
                else {
                    $location.path('/registroDispositivo');
                }
            }
        }, null);
    });
}